var Update = function() {

    var wgtVer = null;
    var _updateFoler = "doc/update/";
    var init = function() {
        //清除下载的文件夹
        plus.io.resolveLocalFileSystemURL("_downloads/" + _updateFoler, function(entry) {
            var directoryReader = entry.createReader();
            directoryReader.readEntries(function(entries) {
                console.log("_downloads file length:" + entries.length);
                for(var i = 0; i < entries.length; i++) {
                    entries[i].remove(function(ee) {
                        console.log("remove succeeded");
                    }, function(e) {
                        console.log("remove fail:" + e.message);
                    });
                }
            }, function(e) {
                console.log("Read entries failed: " + e.message);
            });
        }, function(e) {
            console.log("Resolve file URL: " + e.message);
        });
        document.getElementById("spinerSpan").style.width = "20%";
        // 获取本地应用资源版本号
        plus.runtime.getProperty(plus.runtime.appid, function(inf) {
            wgtVer = inf.version;
            console.log("当前应用版本：" + wgtVer);
            //获取系统类型
            update();
        });
    };

    var update = function() {
        var _ajaxUrl = ""; //获取升级描述文件服务器地址
        if(mui.os.ios) {
            _ajaxUrl = "http://125.88.182.60:8080/update/weixiaoupdate.json";
        } else if(mui.os.android) {
            _ajaxUrl = "http://125.88.182.60:8080/update/weixiaoupdate.json";
        }
        if(_ajaxUrl != "" && !mui.os.ios) {
        		console.log("andriod updating...");
            jQuery.ajax({
                url: _ajaxUrl,
                type: 'GET',
                timeout : 5000,
                error: function(e) {
                    plus.nativeUI.closeWaiting();
                    console.log("error------------------"+JSON.stringify(e));
                },
                success: function(data) {
                    document.getElementById("spinerSpan").style.width = "50%";
                    var serverVer = data.version;
                    console.log("服务器版本：" + serverVer);
                    document.getElementById("serverVersionDiv").innerHTML = "/ " + serverVer;
                    console.log("wgtVer" + wgtVer + serverVer);
                    if(wgtVer && serverVer && (wgtVer != serverVer)) {
                        var versionurl = data.updatefileurl;
                        if(versionurl != null && versionurl != '') {
                            console.log("存在更新：" + versionurl);
                            document.getElementById("spinerSpan").style.width = "70%";
                            downWgt(versionurl); // 下载升级包
                        } else {
                            document.getElementById("spinerSpan").style.width = "90%";
                            goInto();
                        }
                    } else {
                        document.getElementById("spinerSpan").style.width = "90%";
                        goInto();
                    }
                }
            });
        } else {
        		console.log("IOS into...");
            document.getElementById("spinerSpan").style.width = "90%";
            goInto();
        }
    };

    var downWgt = function(versionurl, flag) {
        plus.nativeUI.showWaiting("下载更新文件...");
        plus.downloader.createDownload(versionurl, {
            method: "GET",
            filename: _updateFoler
        }, function(d, status) {
            document.getElementById("spinerSpan").style.width = "90%";
            if(status == 200) {
                console.log("下载更新成功：" + d.filename);
                installWgt(d.filename); // 安装wgt包
            } else {
                console.log("下载更新失败！");
				goInto();
            }
            plus.nativeUI.closeWaiting();
        }).start();
    };

    // 更新应用资源
    var installWgt = function(path) {
        plus.nativeUI.showWaiting("安装更新文件..." + path);
        plus.runtime.install(path, {}, function() {
            plus.nativeUI.closeWaiting();
            console.log("安装更新文件成功！");
            document.getElementById("spinerSpan").style.width = "100%";
            plus.runtime.restart();
        }, function(e) {
            plus.nativeUI.closeWaiting();
            console.log("安装更新文件失败[" + e.code + "]：" + e.message);
			goInto();
        });
        document.getElementById("spinerSpan").style.width = "95%";
    };

    var goInto = function() {
		var ConfigStorageKey = Config.getConfigStorageKey();
    		var isAutoLogin = plus.storage.getItem(ConfigStorageKey.AUTOLOGIN); //是否自动登录
    		if (isAutoLogin) { 
	        DDSystem.autoLogin();
    		} else {
    			//跳转到登陆页面
	        var ConfigWinId = Config.getConfigWinId();
	        Config.closeAllWindow();
	        var hrul = "views/system/login.html";
	        mui.openWindow({
	            id: ConfigWinId.LOGIN,
	            url: hrul
	        });
    		}
    };

    return {
        init: function() {
            init();
        },
        goInto: function() {
        		goInto();
        }
    };
}();