var Config = function() {
	//存储时候要用的key
	var ConfigStorageKey = new Object();
	ConfigStorageKey.SERVER = "dd.server";
	ConfigStorageKey.AUTOLOGIN = "dd.isAutoLogin";
	ConfigStorageKey.LOGINUSER = "loginUserId";
	ConfigStorageKey.HEADER_KEY = "kvQyrQKw4Bk=";
	ConfigStorageKey.LOGIN_USER = "dd.login.loginname";
	ConfigStorageKey.LOGIN_PW = "dd.login.password";

	var ConfigWinId = new Object();
	ConfigWinId.LOGIN = "wd_login";
	ConfigWinId.AUTO_LOGIN = "wd_auto_login";
	ConfigWinId.SERVER = "wd_server";
	ConfigWinId.START = "wd_start";
	ConfigWinId.HOME = "wd_home";
	ConfigWinId.MAIN = "wd_main";
	ConfigWinId.PROJECT = "wd_project";
	ConfigWinId.USER = "wd_user";
	ConfigWinId.MESSAGE="wd_message";
	ConfigWinId.FINANCE="wd_finance";
	ConfigWinId.REPORT="wd_report";
	
	ConfigWinId.PROJECT_ONE = "wd_project_one";
	ConfigWinId.PROJECT_INFO = "wd_project_info";
	ConfigWinId.PROJECT_C = "wd_project_count";
	ConfigWinId.PROJECT_SEARCH = "wd_project_search";
	ConfigWinId.WEB_URL = "wd_web_url";
	ConfigWinId.USER_RESETPW = "wd_reset_pw";
	ConfigWinId.OTHERS = "wd_others";
	ConfigWinId.ABOUT_HELP = "wd_about";
	

	//调用的API接口地址
	var ConfigAPI = new Object();
	ConfigAPI.SUCCESS = "0";
	ConfigAPI.FAIL = "1";

	ConfigAPI.A1000 = "/ws/userService/login";

	ConfigAPI.A2000 = "/ws/chartService/chartProjectByTime";
	ConfigAPI.A2001 = "/ws/chartService/chartProjectByIndustry";
	ConfigAPI.A2002 = "/ws/chartService/chartProjectByPM";

	ConfigAPI.A3000 = "/ws/userService/userInfo";
	ConfigAPI.A3100 = "/ws/userService/updatePassword";

	ConfigAPI.A4000 = "/ws/dimService/findEdimList";

	ConfigAPI.A5000 = "/ws/ProjectService/countProByIndustry";
	ConfigAPI.A5001 = "/ws/ProjectService/countProByCity";
	ConfigAPI.A5002 = "/ws/ProjectService/countProByPM";
	ConfigAPI.A5003 = "/ws/ProjectService/countProByFund";
	ConfigAPI.A5003 = "/ws/ProjectService/countProByFund";
	ConfigAPI.A50031 = "/ws/ProjectService/countProBySee";
	
	ConfigAPI.A5004 = "/ws/ProjectService/findProjectList";
	ConfigAPI.A5005 = "/ws/ProjectService/findProjectBaseInfo";
	ConfigAPI.A5006 = "/ws/ProjectService/findProjectProgress";
	ConfigAPI.A5007 = "/ws/ProjectService/findManagementTeam";
	ConfigAPI.A50071 = "/ws/ProjectService/findManagementById";
	ConfigAPI.A5008 = "/ws/ProjectService/findProjectTeam";
	ConfigAPI.A5009 = "/ws/ProjectService/findProjectDoc";
	ConfigAPI.A5010 = "/ws/ProjectService/findOperateIndex";
	ConfigAPI.A50101 = "/ws/ProjectService/findOperateIndexDetail";
	
	ConfigAPI.A5011 = "/ws/ProjectService/findProjectProgress";
	ConfigAPI.A5012 = "/ws/ProjectService/addProjectProgress";
	ConfigAPI.A5013 = "/ws/ProjectService/findShareholdingStructure";
	ConfigAPI.A5014 = "/ws/ProjectService/findInvestScheme";
	ConfigAPI.A5015 = "/ws/ProjectService/findProjectRoundList";
	ConfigAPI.A5016 = "/ws/ProjectService/findProjectRoundInfo";
	ConfigAPI.A5017 = "/ws/ProjectService/findProjectRoundTradFramework";
	ConfigAPI.A5018 = "/ws/ProjectService/findProjectRoundDeal";
	
	ConfigAPI.A5019 = "/ws/ProjectService/addProjectSee";
	
	ConfigAPI.A5020 = "/ws/ReportService/findSimplifieldDatas";
	ConfigAPI.A5021 = "/ws/ReportService/findGuziTableDatas";
	ConfigAPI.A5022 = "/ws/FundService/findAllFunds";
	
	ConfigAPI.A6000 = "/ws/taskService/acceptTask";
	ConfigAPI.A6001 = "/ws/taskService/submitTask";
	ConfigAPI.A6002 = "/ws/uploadImgService/uploadTaskImgs";
	ConfigAPI.A6003 = "/ws/taskService/findCurrentTask";
	ConfigAPI.A6004 = "/ws/taskService/giveUpTask";
	ConfigAPI.A6005 = "/ws/taskService/reflashTask";
	

	//配置的项
	var ConfigItem = new Object();
	ConfigItem.SERVER = "http://125.88.182.60:8080/TouPiaoApp";
	//ConfigItem.SERVER = "http://localhost:8080/invest";

	var getConfigAPI = function() {
		return ConfigAPI;
	};

	var setConfigItemServer = function(server) {
//		ConfigItem.SERVER = server;
	};

	var getConfigItem = function() {
//		ConfigItem.SERVER = "";
//		ConfigItem.SERVER = plus.storage.getItem(ConfigStorageKey.SERVER);
		return ConfigItem;
	};

	var getConfigStorageKey = function() {
		return ConfigStorageKey;
	};

	var getConfigWinId = function() {
		return ConfigWinId;
	};

	var itemServerinit = function() {
//		var ConfigItem = Config.getConfigItem();
//		ConfigItem.SERVER = "";
//		ConfigItem.SERVER = plus.storage.getItem(ConfigStorageKey.SERVER);
	};

	var closeAllWindow = function() {
		var cuId = plus.webview.currentWebview().id;
		var wvs = plus.webview.all();
		for(var i = 0; i < wvs.length; i++) {
			if(wvs[i].id != cuId) {
				if(wvs[i].id != 'HBuilder') { //主体webview不要关闭
					console.log("Closing webview:" + wvs[i].id);
					wvs[i].close();
				}
			}
		}
	};

	return {
		init: function() {
			mui.plusReady(function() {
				itemServerinit();
			});
		},
		getConfigAPI: function() {
			return getConfigAPI();
		},
		getConfigItem: function() {
			return getConfigItem();
		},
		getConfigStorageKey: function() {
			return getConfigStorageKey();
		},
		getConfigWinId: function() {
			return getConfigWinId();
		},
		closeAllWindow: function() {
			closeAllWindow();
		},
		setConfigItemServer: function(server) {
			setConfigItemServer(server);
		}
	};
}();

Config.init();