var GlobalUtil = function() {
	/**
	 * 需要base64.js,Base64三重加密传输
	 */
	var paramEncryption = function(paramValue) {
		if(paramValue != undefined && paramValue != null && paramValue != '') {
			var base64 = new Base64();
			// 三次加密
			paramValue = base64.encode(paramValue);
			paramValue = base64.encode(paramValue);
			paramValue = base64.encode(paramValue);
		}
		return paramValue;
	};
	/**
	 * 需要base64.js,Base64三重解密
	 */
	var paramDecryption = function(paramValue) {
		if(paramValue != undefined && paramValue != null && paramValue != '') {
			var base64 = new Base64();
			// 三次解密
			paramValue = base64.decode(paramValue);
			paramValue = base64.decode(paramValue);
			paramValue = base64.decode(paramValue);
		}
		return paramValue;
	};
	/**
	 * 取值空处理
	 */
	var dataNullDeal = function(v) {
		if(v == undefined || v == null || v == '') {
			return v = '';
		} else {
			return v;
		}
	};

	/**
	 * js加法误差解决
	 */
	var addValue = function(value1, value2) {
		if(value1 == "")
			value1 = "0";
		if(value2 == "")
			value2 = "0";
		var temp1 = 0;
		var temp2 = 0;
		if(value1.indexOf(".") != -1)
			temp1 = value1.length - value1.indexOf(".") - 1;
		if(value2.indexOf(".") != -1)
			temp2 = value2.length - value2.indexOf(".") - 1;

		var temp = 0;

		if(temp1 > temp2)
			temp = (parseFloat(value1) + parseFloat(value2)).toFixed(temp1);
		else
			temp = (parseFloat(value1) + parseFloat(value2)).toFixed(temp2);

		return temp;
	};
	/**
	 * js减法误差解决
	 */
	var subValue = function(value1, value2) {
		if(value1 == "")
			value1 = "0";
		if(value2 == "")
			value2 = "0";
		var temp1 = 0;
		var temp2 = 0;
		if(value1.indexOf(".") != -1)
			temp1 = value1.length - value1.indexOf(".") - 1;
		if(value2.indexOf(".") != -1)
			temp2 = value2.length - value2.indexOf(".") - 1;
		var temp = 0;

		if(temp1 > temp2)
			temp = (parseFloat(value1) - parseFloat(value2)).toFixed(temp1);
		else
			temp = (parseFloat(value1) - parseFloat(value2)).toFixed(temp2);

		return temp;

	};

	/**
	 * 财务数据千分为显示
	 */
	var finnanceDataFormat = function(number) {
		number = $.trim(number);
		var re = /\d{1,3}(?=(\d{3})+$)/g;
		var n1 = "";
		if(Number(number) < 0) {
			n1 = "-";
			number = number.replace(/-/g, '');
		}
		n1 += number.replace(/^(\d+)((\.\d+)?)$/, function(s, s1, s2) {
			return s1.replace(re, "$&,") + s2;
		});
		return n1;
	};
	/**
	 * 财务数据取消千分位显示
	 */
	var finnanceDataCancel = function(number) {
		number = $.trim(number);
		return number.replace(/,/g, '');
	};

	/**
	 * 从URL中获取参数
	 * @param {Object} name
	 */
	var getQueryString = function(hurl, name) {
		var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
		var r = hurl.substr(1).match(reg); // 获取url中"?"符后的字符串并正则匹配
		var context = "";
		if(r != null) {
			context = r[2];
		}
		reg = null;
		r = null;
		return context == null || context == "" || context == "undefined" ? "" : context;
	};

	/**
	 *判断输入框中输入的日期格式为yyyy-mm-dd和正确的日期
	 */
	var isDate = function(mystring) {
		var reg = /^(\d{4})-(\d{2})-(\d{2})$/;
		var str = mystring;
		var arr = reg.exec(str);
		if(str == "") return true;
		if(!reg.test(str) && RegExp.$2 <= 12 && RegExp.$3 <= 31) {
			return false;
		}
		return true;
	};

	return {
		finnanceDataCancel: function(n) {
			return finnanceDataCancel(n);
		},
		finnanceDataFormat: function(d) {
			return finnanceDataFormat(d);
		},
		paramEncryption: function(d) {
			return paramEncryption(d);
		},
		paramDecryption: function(d) {
			return paramDecryption(d);
		},
		addValue: function(value1, value2) {
			return addValue(value1, value2);
		},
		subValue: function(value1, value2) {
			return subValue(value1, value2);
		},
		dataNullDeal: function(v) {
			return dataNullDeal(v);
		},
		getQueryString: function(hurl, name) {
			return getQueryString(hurl, name);
		},
		isDate: function(str) {
			return isDate(str);
		}
	};
}();